


// *** LCD 2119   2x16 car sur bus I2C  ***********


void LCD_CLS()
{
// d'abord la ligne 2 pour avoir le curseur en 0 de ligne 1
LCD_RAZ_Ligne(2);
LCD_RAZ_Ligne(1);
}

/*
void LCD_Clear()
{
 // problematique car CGM type R
int j;
I2C2_Start();
j=I2C2_Wr(LCD_ADR); // i2c slave Address
j=I2C2_Wr(0x00);
j=I2C2_Wr(0x24);
j=I2C2_Wr(0x06);
j=I2C2_Wr(0x02);
j=I2C2_Wr(0x01);
j=I2C2_Wr(0x40);
I2C2_Stop();
}
*/

int LCD2119_Init(void)
{
// see datasheet PCF2119x NXP Semiconductorspage 69
int j,k;
k=0;
Delay_ms(500);
I2C2_Start();
j=I2C2_Wr(LCD_ADR); // i2c slave Address
if (j!=0) return k;
k++;
Delay_ms(200);
j=I2C2_Wr(0x00);    // Control byte for Instruction
if (j>0) return k;
k++;
I2C2_Wr(0x24); //0x20 +  DL=0 format 4 ou 8 bits not used, M=1 car 2x16 cars display, SL=0 1:18, H: mode standard
I2C2_Wr(0x0C); // D: Display on, C: curser off, B: blink off
I2C2_Wr(0x06); // Entry mode set : I/D: increment, S: no shift
I2C2_Wr(0x25); // DL: 8 bits, M: 16 by two line, SL: 1:18, H: extended instruction set
//I2C2_Wr(0x04); // P: left to right, Q: top to bottom    sur connecteur A
I2C2_Wr(0x06); // P: Right to left ,Q: top to bottom      sur connecteur B
I2C2_Wr(0x11); // TC1: 0, TC0: 1
I2C2_Wr(0x42); // HV Stages 3
//I2C2_Wr(0x9f); // set Vlcd, store to VA
I2C2_Wr(0x96); // set Vlcd, store to VA  (avec alim=3,3V)
j=I2C2_Wr(0x24); // DL: 8 bits, M: two line, SL: 1:18, H: normal instruction set
if (j>0) return k;
k++;
j=I2C2_Wr(0x0C);
if (j>0) return k;
k++;
j=I2C2_Wr(0x06);
if (j>0) return k;
k++;
j=I2C2_Wr(0x02); // return home
if (j>0) return k;
k++;
// avec LC2119 RU  remplissage avec caractere >> au lieu de blanc=espace
/// il faut un modele LCD2119 AU  !
j=I2C2_Wr(0x01); // clear display
if (j>0) return k;
Delay_ms(100);
I2C2_Stop();
k++;
return k;
}

void LCD_RAZ_Ligne( int L)
{  int i;
 I2C2_Start();
 I2C2_Wr(LCD_ADR); // i2c slave Address
 I2C2_Wr(0x00); // Control byte for Instruction
 I2C2_Wr(0x02); // return home
 switch (L)
 {
  case 1:
      I2C2_Wr(0x80); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C2_Wr(0xC0); // DDRAM Address 2em ligne
      break;
  default:
  break ;
 }
 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR); // i2c slave Adress
 I2C2_Wr(0x40);     // Control byte for Data
 for (i=0;i<39;i++)
 {
   I2C2_Wr(0x80+32); // efface avec des blanc
 }
 // repositionne au debut de ligne
 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR); // i2c slave Adress
 I2C2_Wr(0x00); // Control byte for Instruction
 //I2C2_Wr(0x40);     // Control byte for Data
 switch (L)
  {
   case 1:
         I2C2_Wr(0x80); // DDRAM Address 1ere ligne
        break;
   case 2:
        I2C2_Wr(0xC0); // DDRAM Address 2em ligne
        break;
   default:
        break ;
  }
 I2C2_Stop();
}


void LCD_Write_CText(const char * t1)
 {
  char TT[17];
  int i;
  strConstRamCpy(TT,t1);
  I2C2_Start();
  I2C2_Wr(LCD_ADR); // i2c slave Address
  I2C2_Wr(0x00); // Control byte for Instruction
 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR); // i2c slave Adress
 I2C2_Wr(0x40); // Control byte for Data
 i=0;
 while(*(t1))
 {
  I2C2_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
 }
 I2C2_Stop();
}


void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1)
 {
  char TT[17];
  int i;
  strConstRamCpy(TT,t1);
  I2C2_Start();
  I2C2_Wr(LCD_ADR); // i2c slave Address
  I2C2_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
 {
  case 1:
      I2C2_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C2_Wr(0xc0+col-1); // DDRAM Address 2em ligne
        break;
  default:
  break ;
 }
 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR); // i2c slave Adress
 I2C2_Wr(0x40); // Control byte for Data
 i=0;
 while(*(t1))
 {
  I2C2_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
 }
 I2C2_Stop();
}



void LCD_Write_Chr_At(int Ligne,int col,char c1)
{ //.. ligne 1 ou 2
  //.. col de 1  16
  // .. Special =0 pour ascii normal   1 pour caracteres perso definis en CGRAM
  I2C2_Start() ;
  I2C2_Wr(LCD_ADR); // i2c slave Adress
  I2C2_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
  {
  case 1:
      I2C2_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C2_Wr(0xc0+col-1); // DDRAM Address 2em ligne
      break;
  default:
      break ;
  }
  I2C2_Repeated_Start() ;
  I2C2_Wr(LCD_ADR); // i2c slave Address
  I2C2_Wr(0x40); // Control byte for Data
  I2C2_Wr(0x80+c1);
  Delay_ms(10);                      // Pause de 10ms
  I2C2_Stop();
 }

void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1)
{ //.. ligne 1 ou 2
  //.. col de 1  16
  int i;
  I2C2_Start();
  I2C2_Wr(LCD_ADR); // i2c slave Address
  I2C2_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
  {
  case 1:
      I2C2_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C2_Wr(0xc0+col-1); // DDRAM Address 2em ligne
      break;
  default:
      break ;
  }
  I2C2_Repeated_Start();
  I2C2_Wr(LCD_ADR); // i2c slave Adress
  I2C2_Wr(0x40); // Control byte for Data
  i=0;
  while(*(t1))
  {
  I2C2_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
  }
  I2C2_Stop();
}

void LCD_Home()
{
 LCD_Cde(0x02);
}


void LCD_Droite()
{
  LCD_Cde(0x014);
 }

void LCD_Cde(unsigned char Cde)
{
 I2C2_Start();
 I2C2_Wr(0x76); //Display adress
 I2C2_Wr(0x00); //Register Select Config Register
 I2C2_Wr(Cde); //Write Data
 I2C2_Stop();
}

void LCD_Gauche()
{
  LCD_Cde(0x010);
 }


unsigned char check_device(unsigned char dev_address)
{
char Etat;
strConstRamCpy(txt,"Device at adresse : ");
k=strlen(txt);
ByteToStr(dev_address,CRam1);
strcat(txt+k,CRam1);
UART1_Write_Text(txt);
I2C2_Start();
if(I2C2_Wr(dev_address)!=0 )
 {
 UART1_Write_CText(" is not found\r\n");
  Etat=0;
 }
 else
 {
 UART1_Write_CText(" found OK\r\n");
  Etat=1;
  }
I2C2_Stop();
 return Etat;
}
